package il.ac.tau.cs.sw1.trie;

import java.util.Set;

public class TrieTest {

	public static void main(String[] args) {
		Trie<String, String> names = new StringTrie<>();
		System.out.println("*Before* adding any names");
		System.out
				.println("Should find 0 values for \"bill\", found: "
						+ names.searchByPrefix("bill").size());
		System.out
				.println("Should find 0 values for \"billy\", found: "
						+ names.searchByPrefix("billy").size());
		System.out
				.println("Should find 0 values for \"billie\", found: "
						+ names.searchByPrefix("billie").size());
		System.out.println("Should find 0 values for \"al\", found: "
				+ names.searchByPrefix("al").size());

		names.addKey("bill", "Murray");
		names.addKey("billie", "Holiday");
		names.addKey("bill", "Gates");
		names.addKey("bill", "Murray");
		names.addKey("albert", "Einstein");

		System.out.println("\n\n*After* adding the names");
		Set<String> values = names.searchByPrefix("bill");
		System.out
				.println("\nShould find 3 values for \"bill\", found: "
						+ values.size());
		System.out
				.println("The values should be [Gates, Holiday, Murray] (in some order): "
						+ values);
		values = names.searchByPrefix("billy");
		System.out
				.println("\nShould find 0 values for \"billy\", found: "
						+ values.size());
		System.out.println("The values should be []: " + values);
		values = names.searchByPrefix("billie");
		System.out
				.println("\nShould find 1 value for \"billie\", found: "
						+ values.size());
		System.out.println("The values should be [Holiday]: "
				+ values);
		values = names.searchByPrefix("al");
		System.out
				.println("\nShould find 1 value for \"al\", found: "
						+ values.size());
		System.out.println("The values should be [Einstein]: "
				+ values);
	}

}
